## org.apache.mahout.df.mapreduce.partial
Class PartialBuilder

    java.lang.Object
      org.apache.mahout.df.mapreduce.Builder
          org.apache.mahout.df.mapreduce.partial.PartialBuilder

    public class PartialBuilder

extends Builder

Builds a random forest using partial data. Each mapper uses only the data given by its InputSplit

Constructor Summary
`PartialBuilder(TreeBuilder treeBuilder, org.apache.hadoop.fs.Path dataPath, org.apache.hadoop.fs.Path datasetPath, java.lang.Long seed)`
`PartialBuilder(TreeBuilder treeBuilder, org.apache.hadoop.fs.Path dataPath, org.apache.hadoop.fs.Path datasetPath, java.lang.Long seed, org.apache.hadoop.conf.Configuration conf)`

Method Summary
`protected void` `configureJob(org.apache.hadoop.mapreduce.Job job, int nbTrees, boolean oobEstimate)` Used by the inheriting classes to configure the job
`protected static boolean` `isStep2(org.apache.hadoop.conf.Configuration conf)` Indicates if we should run the second step of the builder. This parameter is only meant for debuging, so we keep it protected.
`protected DecisionForest` `parseOutput(org.apache.hadoop.mapreduce.Job job, PredictionCallback callback)` Parse the output files to extract the trees and pass the predictions to the callback
`protected static void` `processOutput(org.apache.hadoop.mapreduce.JobContext job, org.apache.hadoop.fs.Path outputPath, int[] firstIds, TreeID[] keys, Node[] trees, PredictionCallback callback)` Processes the output from the output path.
`protected static void` `setStep2(org.apache.hadoop.conf.Configuration conf, boolean value)` Should run the second step of the builder ?

Methods inherited from class org.apache.mahout.df.mapreduce.Builder
`build, getDataPath, getDatasetPath, getDistributedCacheFile, getNbTrees, getNumMaps, getOutputPath, getRandomSeed, getSeed, getTreeBuilder, getTreeBuilder, isOobEstimate, isOutput, loadDataset, runJob, setNbTrees, setOutputDirName, sortSplits`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### PartialBuilder

    public PartialBuilder(TreeBuilder treeBuilder,
                          org.apache.hadoop.fs.Path dataPath,
                          org.apache.hadoop.fs.Path datasetPath,
                          java.lang.Long seed)

### PartialBuilder

    public PartialBuilder(TreeBuilder treeBuilder,
                          org.apache.hadoop.fs.Path dataPath,
                          org.apache.hadoop.fs.Path datasetPath,
                          java.lang.Long seed,
                          org.apache.hadoop.conf.Configuration conf)

Method Detail

### isStep2

    protected static boolean isStep2(org.apache.hadoop.conf.Configuration conf)

  Indicates if we should run the second step of the builder.
  This parameter is only meant for debuging, so we keep it protected.

### setStep2

    protected static void setStep2(org.apache.hadoop.conf.Configuration conf,
                                   boolean value)

  Should run the second step of the builder ?

  Parameters:
    `value` - true to indicate that the second step will be launched

### configureJob

    protected void configureJob(org.apache.hadoop.mapreduce.Job job,
                                int nbTrees,
                                boolean oobEstimate)
                         throws java.io.IOException

  Description copied from class: `Builder`
  Used by the inheriting classes to configure the job

  Specified by:
    `configureJob` in class `Builder`
  Parameters:
    `job` - Hadoop's Job
    `nbTrees` - number of trees to grow
    `oobEstimate` - true, if oob error should be estimated
  Throws:
    `java.io.IOException` - if anything goes wrong while configuring the job

### parseOutput

    protected DecisionForest parseOutput(org.apache.hadoop.mapreduce.Job job,
                                         PredictionCallback callback)
                                  throws java.io.IOException,
                                         java.lang.ClassNotFoundException,
                                         java.lang.InterruptedException

  Description copied from class: `Builder`
  Parse the output files to extract the trees and pass the predictions to the callback

  Specified by:
    `parseOutput` in class `Builder`
  Parameters:
    `job` - Hadoop's job
    `callback` - can be null
  Returns:
    Built DecisionForest
  Throws:
    `java.io.IOException` - if anything goes wrong while parsing the output
    `java.lang.ClassNotFoundException`
    `java.lang.InterruptedException`

### processOutput

    protected static void processOutput(org.apache.hadoop.mapreduce.JobContext job,
                                        org.apache.hadoop.fs.Path outputPath,
                                        int[] firstIds,
                                        TreeID[] keys,
                                        Node[] trees,
                                        PredictionCallback callback)
                                 throws java.io.IOException

  Processes the output from the output path.

  Parameters:
    `job` -
    `outputPath` - directory that contains the output of the job
    `firstIds` - partitions' first ids in hadoop's order
    `keys` - can be null
    `trees` - can be null
    `callback` - can be null
  Throws:
    `java.io.IOException`

Copyright © 2008-2010 The Apache Software Foundation. All Rights Reserved.